VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsConnectionHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'This class is soley for handling BNCS and BNLS Handlers.

'WithEvents procedure allows the Connection class to handle all their public events
Public WithEvents BNCSHandler      As clsBNCSHandler
Attribute BNCSHandler.VB_VarHelpID = -1
Public WithEvents BNLSHandler      As clsBNLSHandler
Attribute BNLSHandler.VB_VarHelpID = -1
Public WithEvents MCPHandler       As clsMCPHandler
Attribute MCPHandler.VB_VarHelpID = -1

'Initialization
Private Sub Class_Initialize()
    Set BNCSHandler = New clsBNCSHandler
    Set BNLSHandler = New clsBNLSHandler
    Set MCPHandler = New clsMCPHandler
End Sub

'Termination
Private Sub Class_Terminate()
    Set BNCSHandler = Nothing
    Set BNLSHandler = Nothing
    Set MCPHandler = Nothing
End Sub

'Class RaisedEvents:

    '- BNCS Events
Private Sub BNCSHandler_OutputPacketRecieved(ByVal Index As Integer, ByVal PacketID As String)
    If (G_Options.Debug_Mode) Then
        AddC Index, frmMain.rtbChat, True, COLORS.DBG_RECEIVED, hBNET & rPkt & PacketID
    End If
End Sub

Private Sub BNCSHandler_OutputPacketSent(ByVal Index As Integer, ByVal PacketID As String)
    If (G_Options.Debug_Mode) Then
        AddC Index, frmMain.rtbChat, True, COLORS.DBG_SENT, hBNET & sPkt & PacketID
    End If
End Sub

Private Sub BNCSHandler_BNLSVersionCheck(ByVal Index As Integer)
    Call BNLSHandler.setClassVars(Index, frmMain.sckBNLS(Index))
    
    If (Bots(Index).Client = PRODUCT_WAR3 Or Bots(Index).Client = PRODUCT_W3XP) Then
        BNLSHandler.sendBNLS_CHOOSENLSREVISION
        BNLSHandler.sendBNLS_VERSIONCHECK
    Else
        BNLSHandler.sendBNLS_VERSIONCHECK
    End If
End Sub

Private Sub BNCSHandler_ShowProfile()
    frmProfile.loadProfileInformation
    frmProfile.Show
End Sub

Private Sub BNCSHandler_DisplayAvailableChannel(ByVal Index As Integer, ByVal Output As String)
    If (Left$(Output, 4) = Space(3) & "-") Then
        AddC Index, frmMain.rtbChat, True, COLORS.ID_COLOR_INFO, Output
    Else
        AddC Index, frmMain.rtbChat, True, COLORS.ID_COLOR_SUCCEED, Output
    End If
End Sub

Private Sub BNCSHandler_DisplaySystemKey(ByVal Index As Integer, ByVal Output As String)
    AddC Index, frmMain.rtbChat, True, COLORS.ID_COLOR_INFO, Output
End Sub

Private Sub BNCSHandler_LadderSearchCallBack(lRank As Long)
    If lRank <> &HFFFFFFFF Then
        frmLadder.Position = lRank
        frmLadder.requestLadder
    Else
        MsgBox "User is not ranked."
    End If
End Sub



    '- BNLS Events
    
Private Sub BNLSHandler_SendAuthCheck(ByVal Index As Integer)
    With ConnectionHandler
        Call .BNCSHandler.setClassVars(Index, frmMain.sckBNET(Index))
        Call .BNCSHandler.sendSID_AUTH_CHECK
    End With
End Sub

Private Sub BNLSHandler_SendAuthInfo(ByVal Index As Integer)
    Call BNCSHandler.setClassVars(Index, frmMain.sckBNET(Index))
    Call BNCSHandler.sendSID_AUTH_INFO
End Sub

Private Sub BNLSHandler_OutputPacketRecieved(ByVal Index As Integer, ByVal PacketID As String)
    If (G_Options.Debug_Mode) Then
        AddC Index, frmMain.rtbChat, True, COLORS.DBG_RECEIVED, hBNET & rPkt & PacketID
    End If
End Sub

Private Sub BNLSHandler_OutputPacketSent(ByVal Index As Integer, ByVal PacketID As String)
    If (G_Options.Debug_Mode) Then
        AddC Index, frmMain.rtbChat, True, COLORS.DBG_SENT, hBNET & sPkt & PacketID
    End If
End Sub
    
    '- MCP Events
    
Private Sub MCPHandler_OutputPacketRecieved(ByVal Index As Integer, ByVal PacketID As String)
    If (G_Options.Debug_Mode) Then
        AddC Index, frmMain.rtbChat, True, COLORS.DBG_RECEIVED, hMCP & rPkt & PacketID
    End If
End Sub

Private Sub MCPHandler_OutputPacketSent(ByVal Index As Integer, ByVal PacketID As String)
    If (G_Options.Debug_Mode) Then
        AddC Index, frmMain.rtbChat, True, COLORS.DBG_SENT, hMCP & sPkt & PacketID
    End If
End Sub
