VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsQueue"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private PriorityStatus  As Boolean '1 = highest priority
Private LastMessageSent As Long
Private Queue()         As QE
Private Type QE
    Message             As String
    Priority            As Byte
End Type

Private Sub Class_Initialize()
    ReDim Queue(0)
End Sub

Private Sub Class_Terminate()
    ReDim Queue(0)
End Sub

Public Property Let myPriorityStatus(ByRef Value As Boolean)
    PriorityStatus = Value
End Property

Public Property Get myPriorityStatus() As Boolean
    myPriorityStatus = PriorityStatus
End Property

Public Function PeekQueue(ByVal Index As Integer)
     If Index - 1 > UBound(Queue) Then Exit Function
     PeekQueue = Queue(Index).Message
End Function

Public Sub ResetQueue()
     ReDim Queue(0)
End Sub

Public Sub AddQueue(ByVal Message As String, ByVal Priority As Byte)
     Queue(UBound(Queue)).Message = Message
     Queue(UBound(Queue)).Priority = Priority
     ReDim Preserve Queue(UBound(Queue) + 1)
End Sub

Public Sub InsertQueue(ByVal Index As Integer, ByVal Message As String, ByVal Priority As Byte)
     If Index - 1 > UBound(Queue) Then Exit Sub
     Dim i As Integer, TempBuf As String
     For i = UBound(Queue) - 1 To Index Step -1
          Queue(i + 1) = Queue(i)
     Next i
     Queue(Index).Message = Message
     Queue(Index).Priority = Priority
     
     ReDim Preserve Queue(UBound(Queue) + 1)
End Sub

Public Sub DeleteQueue(ByVal Index As Integer)
     If Index - 1 > UBound(Queue) Then Exit Sub
     Dim i As Integer
     For i = Index To UBound(Queue) - 1
          Queue(i) = Queue(i + 1)
     Next i
     ReDim Preserve Queue(UBound(Queue) - 1)
End Sub

Private Sub StepQueue()
     If UBound(Queue) = 0 Then Exit Sub
     Dim i As Integer
     For i = 0 To UBound(Queue) - 1
          Queue(i) = Queue(i + 1)
     Next i
     ReDim Preserve Queue(UBound(Queue) - 1)
End Sub

Public Function GetQueue() As String
    Dim i                   As Integer
    Dim LastQueuePriority   As Integer 'Holds the index for the array
    If (PriorityStatus) Then
        For i = 0 To UBound(Queue) - 1
            If (Queue(i).Priority <> 0 And i <> 0 And Queue(i).Priority < Queue(LastQueuePriority).Priority) Then
                LastQueuePriority = i
            End If
        Next i
        If (CalculateDelay(Queue(LastQueuePriority).Message)) Then
            GetQueue = Queue(LastQueuePriority).Message
            Call DeleteQueue(LastQueuePriority)
        Else
            GetQueue = vbNullString
        End If
    Else
        If (CalculateDelay(Queue(0).Message)) Then
            GetQueue = Queue(0).Message
            Call DeleteQueue(0)
        Else
            GetQueue = vbNullString
        End If
    End If
    LastMessageSent = GetTickCount()
End Function

Public Function QueueCount() As Integer
     QueueCount = UBound(Queue)
End Function

Private Function CalculateDelay(ByRef Message As String) As Boolean
    '// Do something
    CalculateDelay = True
End Function

